package com.fp.persistence.pgeneral.product.rate;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBASERATE*/
@Entity(name="TgeneBaseRate")
@Table(name="TGENEBASERATE")
public class TgeneBaseRate extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBaseRate
*/
@EmbeddedId
private TgeneBaseRateKey pk;
/**Contructor por defecto*/
public TgeneBaseRate(){
}
/**Contructor de TgeneBaseRate
@param pPk Clave Primaria del entity
*/
public TgeneBaseRate(TgeneBaseRateKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBaseRate
*/
public static TgeneBaseRate find(EntityManager pEntityManager,TgeneBaseRateKey pKey) throws Exception{
    TgeneBaseRate obj = pEntityManager.find(TgeneBaseRate.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBaseRate
@return El objeto que referencia a la Clave primaria de TgeneBaseRate
*/
public TgeneBaseRateKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBaseRate
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBaseRate
*/
public void setPk(TgeneBaseRateKey pPk){
  pk=pPk;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBaseRate))return false;
    TgeneBaseRate that = (TgeneBaseRate) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneBaseRate
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneBaseRate
*/
public Object createInstance(){
 TgeneBaseRate instance=new TgeneBaseRate();	
 instance.setPk(new TgeneBaseRateKey());
 return instance;
}
/**Clona la entidad TgeneBaseRate
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBaseRate p=(TgeneBaseRate)this.clone();
  p.setPk((TgeneBaseRateKey)this.pk.cloneMe());
  return p;
}
}
